# encoding: utf-8
#test of backpropagation algorithm

from ann import *
import os

maxerror=0.003

def xor_backpropagation_train(ann):
	"""Backpropagation training data for learning xor. 
	"""
	trainingdata= [([0,1], [1]),([1,0], [1]),([1,1], [0]), ([0,0], [1])]
	
	backpropagation(ann, trainingdata,maxerror)
	
def oa_backpropagation_train(ann):
	"""Backpropagation training data for obstacle
	avoidance on e-puck.
	"""
	frontleft = ([0,0,0,0,0,0,0,300], [-1,0,0,0,0,0,-1,-1])
	frontright = ([300,0,0,0,0,0,0,0], [-1,-1,0,0,0,0,0,-1])
	
	left1 = ([0,0,0,0,0,300,0,0], [0,0,0,0,-1,-1,-1,0])
	left2 = ([0,0,0,0,0,0,300,0], [0,0,0,0,0,-1,-1,-1])
	right1 = ([0,0,300,0,0,0,0,0], [0,-1,-1,-1,0,0,0,0])
	right2 = ([0,300,0,0,0,0,0,0], [-1,-1,-1,0,0,0,0,0])
	backleft = ([0,0,0,300,0,0,0,0], [0,0,-1,-1,0,0,0,0])
	backright = ([0,0,0,0,300,0,0,0], [0,0,0,0,-1,-1,0,0])
	none = ([30,30,30,30,30,30,30,30], [0,0,0,0,0,0,0,0])
	
	trainingdata=[frontleft,frontright,backleft,backright,left1,left1,right1,right2,none]
	backpropagation(ann, trainingdata, maxerror)
	
def main():
	#xornetwork= create_ann(os.path.join(os.getcwd(), "backprop_xor_test.ann"))
	#xor_backpropagation_train(xornetwork)
	#print xornetwork
	
	#testdata= [[0,0],[0,1],[1,0],[1,1]]
	#xornetwork.test(testdata)
	
	oanetwork= create_ann(os.path.join(os.getcwd(), "backprop_oa_test.ann"))
	oa_backpropagation_train(oanetwork)
	#oanetwork=load_object("oanetwork.dat")
	print oanetwork
	
	front=[300,0,0,0,0,0,0,300]
	front2=[0,0,0,0,0,0,0,300]
	none1=[0,0,0,0,0,0,0,0]
	none2=[10,10,10,10,10,10,10,10]
	left1=[0,0,0,0,0,300,0,0]
	right1=[0,0,300,0,0,0,0,0]
	test=[970, 15, 33, 23, 11, 104, 3280, 3574]
	testdata= [front,front2,none1,none2,left1,right1,test]
	oanetwork.test(testdata)
	oanetwork.save("oanetwork.dat")

if __name__ == "__main__":
	main()
